<?php

/**
 * This software is intended for use with Oxwall Free Community Software http://www.oxwall.org/ and is
 * licensed under The BSD license.
 *
 * ---
 * 2014 Dmitry Surin recode Copyright (c) 2013, Unixvers
 * The GPL License.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that the
 * following conditions are met:
 *
 *  - Redistributions of source code must retain the above copyright notice, this list of conditions and
 *  the following disclaimer.
 *
 *  - Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *  the following disclaimer in the documentation and/or other materials provided with the distribution.
 *
 *  - Neither the name of the Oxwall Foundation nor the names of its contributors may be used to endorse or promote products
 *  derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

$plugin = OW::getPluginManager()->getPlugin('glconnect');

//Route che punta al login : glconnect_login
OW::getRouter()->addRoute(new OW_Route('glconnect_oauth', 'glconnect/oauth', 'GLCONNECT_CTRL_Connect', 'oauth'));

//Route che punta alla prima maschera di configurazione
OW::getRouter()->addRoute(new OW_Route('glconnect_admin_main','admin/plugins/glconnect','GLCONNECT_CTRL_Admin', 'index'));
OW::getRouter()->addRoute(new OW_Route('glconnect_app_success_page','admin/plugins/glconnect','GLCONNECT_CRTL_Admin', 'success'));

$configs = OW::getConfig()->getValues('glconnect');
if ( !empty($configs['client_id']) && !empty($configs['client_secret']) ) 
     {
	$registry = OW::getRegistry();
	$registry->addToArray(BASE_CTRL_Join::JOIN_CONNECT_HOOK, array(new GLCONNECT_CMP_ConnectButton(), 'render'));
	$registry->addToArray(BASE_CMP_ConnectButtonList::HOOK_REMOTE_AUTH_BUTTON_LIST, array(new GLCONNECT_CMP_ConnectButton(), 'render'));
     }

function glconnect_event_add_button( BASE_CLASS_EventCollector $event )
{
    $cssUrl = OW::getPluginManager()->getPlugin('GLCONNECT')->getStaticCssUrl() . 'glconnect.css';
    OW::getDocument()->addStyleSheet($cssUrl);
    $button = new GLCONNECT_CMP_ConnectButton();
    $event->add(array('iconClass' => 'ow_ico_signin_g', 'markup' => $button->render()));
}
OW::getEventManager()->bind(BASE_CMP_ConnectButtonList::HOOK_REMOTE_AUTH_BUTTON_LIST, 'glconnect_event_add_button');

//Funzione per notificare che si necessita la configurazione del plugin
function glconnect_add_admin_notification( BASE_CLASS_EventCollector $e )
 {
    $language = OW::getLanguage();
    $configs = OW::getConfig()->getValues('glconnect');
    if ( empty($configs['client_id']) || empty($configs['client_secret']) )
    {
        $e->add($language->text('glconnect', 'admin_configuration_required_notification', array( 'href' => OW::getRouter()->urlForRoute('glconnect_admin_main') )));
    }
 }
OW::getEventManager()->bind('admin.add_admin_notification', 'glconnect_add_admin_notification');

function glconnect_add_access_exception( BASE_CLASS_EventCollector $e ) {
	$e->add(array('controller' => 'GLCONNECT_CTRL_Connect', 'action' => 'oauth'));

}

OW::getEventManager()->bind('base.members_only_exceptions', 'glconnect_add_access_exception');
OW::getEventManager()->bind('base.password_protected_exceptions', 'glconnect_add_access_exception');
OW::getEventManager()->bind('base.splash_screen_exceptions', 'glconnect_add_access_exception');

$eventHandler = new GLCONNECT_CLASS_EventHandler();
$eventHandler->init();